
`define PREKLAD_PRO_VIVADO ANO 
`define POUZE_PRO_SIMULACI ANO 
`define PRIDAT_VYSTUPNI_LATCH1 ANO 

// --------------------------


module DELAY3(input GCLK, input in, output out );

`ifdef PREKLAD_PRO_VIVADO    
  (* ASYNC_REG = "TRUE" *) reg out1_reg;
  (* ASYNC_REG = "TRUE" *) reg out2_reg;
  (* ASYNC_REG = "TRUE" *) reg out3_reg;
`else 
  reg out1_reg;
  reg out2_reg;
  reg out3_reg;
`endif

wire out1_next;
wire out2_next;
wire out3_next;
  
always @(posedge GCLK)
begin
  out1_reg <= out1_next;
  out2_reg <= out2_next;
  out3_reg <= out3_next;
end

assign out1_next = in;
assign out2_next = out1_reg;
assign out3_next = out2_reg;

//assign out = out3_reg;
assign out = out1_reg;
//assign out = in;

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F100_NOT (input GCLK, input I, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end
  
always @(posedge GCLK)
  funkce1 = !I;

`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign nO=funkce1;
`else 
  assign nO=!I;
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F101_NOT_NOT (input GCLK, input I, output O , output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 `else 
   reg funkce1;
   reg funkce2;
`endif

initial begin
  funkce1 = 1'b0;
  funkce2 = 1'b1;
end

always @(posedge GCLK)
begin
  funkce1 = !I;
  funkce2 = !funkce1;
end  

`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign nO=funkce1;
  assign O=funkce2;
`else 
  assign nO=!I;
  assign O=I;
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F102_NOT16 (input GCLK, input I, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = !I;
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
    assign nO=funkce1;
  `else 
    assign nO=!I;
  `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F103_NOT24 (input GCLK, input I, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = !I;
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign nO=funkce1;
`else 
  assign nO=!I;
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F104_NOT32 (input GCLK, input I, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = !I;
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
   assign nO=funkce1;
`else 
   assign nO=!I;
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F105_NOT16_NOT16 (input GCLK, input I, output O , output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 `else 
   reg funkce1;
   reg funkce2;
`endif

initial begin
  funkce1 = 1'b0;
  funkce2 = 1'b1;
end

always @(posedge GCLK)
begin
  funkce1 = !I;
  funkce2 = !funkce1;
end  

`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign nO=funkce1;
  assign O=funkce2;
`else 
  assign nO=!I;
  assign O=I;
`endif


endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F111_Buffer (input GCLK, input I, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = I;

`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O=I;
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F112_Buffer16 (input GCLK, input I, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = I;
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
   assign O=funkce1;
`else 
   assign O=I;
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F113_Buffer24 (input GCLK, input I, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = I;
  
 `ifdef PRIDAT_VYSTUPNI_LATCH  
    assign O=funkce1;
 `else 
    assign O=I;
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F114_Buffer32 (input GCLK, input I, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

always @(posedge GCLK)
  funkce1 = I;
  
 `ifdef PRIDAT_VYSTUPNI_LATCH  
     assign O=funkce1;
 `else 
     assign O=I;
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F202_NOR (input GCLK, input I1, input I2, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 | I2);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O=~(I1 | I2);
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F203_NOR3 (input GCLK, input I1, input I2, input I3, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 | I2 | I3);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
   assign O=funkce1;
 `else 
   assign O= ~(I1 | I2 | I3);
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F204_NOR4 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 | I2 | I3  | I4);
  
 `ifdef PRIDAT_VYSTUPNI_LATCH  
   assign O=funkce1;
`else 
   assign O= ~(I1 | I2 | I3  | I4);
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F212_OR (input GCLK, input I1, input I2, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = (I1 | I2);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
   assign O=funkce1;
 `else 
   assign O= (I1 | I2);
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F301_NAND_NAND (input GCLK, input I1, input I2, input I3, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 =  ~(~(I1 & I2) & I3);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O=~(~(I1 & I2) & I3);
`endif
endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F302_NAND (input GCLK, input I1, input I2, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end


always @(posedge GCLK)
  funkce1 = ~(I1 & I2);
  
  //suk
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
 `else 
  assign O=  ~(I1 & I2);
 `endif
  
endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F303_NAND3 (input GCLK, input I1, input I2, input I3, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 & I2 & I3);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
 `else 
  assign O= ~(I1 & I2 & I3);
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F304_NAND4 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 & I2 & I3 & I4);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O= ~(I1 & I2 & I3 & I4);
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F306_NAND6 (input GCLK, input I1, input I2, input I3, input I4, input I5, input I6, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 & I2 & I3 & I4 & I5 & I6);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O=~(I1 & I2 & I3 & I4 & I5 & I6);
`endif
endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F312_AND (input GCLK, input I1, input I2, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = (I1 & I2);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
 `else 
  assign O=  (I1 & I2);
 `endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F421_AND_NOR_1_2 (input GCLK, input I1, input I2, input I3, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~((I1 & I2) | I3);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O= ~((I1 & I2) | I3);
`endif
endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F422_AND_NOR_1_1_2 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~((I1 & I2) | I3 | I4);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O= ~((I1 & I2) | I3 | I4);
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F423_AND_NOR_1_3 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 =  ~((I1 & I2 & I3) | I4);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O=~((I1 & I2 & I3) | I4);
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F424_AND_NOR_2_2 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)

  funkce1 = ~((I1 & I2) | (I3 & I4)); 
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O= ~((I1 & I2) | (I3 & I4));
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F431_OR_NAND_1_2 (input GCLK, input I1, input I2, input I3, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 =  ~((I1 | I2) & I3);
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O= ~((I1 | I2) & I3);
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F433_OR_NAND_1_3 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~((I1 | I2 | I3) & I4); 
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
`else 
  assign O= ~((I1 | I2 | I3) & I4);
`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F434_OR_NAND_2_2 (input GCLK, input I1, input I2, input I3, input I4, output O );

`ifdef PREKLAD_PRO_VIVADO    
(* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~((I1 | I2) & (I3 | I4)); 
  
`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
 `else 
  assign O= ~((I1 | I2) & (I3 | I4));
`endif

endmodule


// --------------------------


(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F512_NXOR (input GCLK, input I1, input I2, output O );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
`else 
   reg funkce1;
`endif

initial begin
  funkce1 = 1'b0;
end

always @(posedge GCLK)
  funkce1 = ~(I1 ^ I2);

`ifdef PRIDAT_VYSTUPNI_LATCH  
assign O=funkce1;
`else 
assign O=  ~(I1 ^ I2);
`endif
  
endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F521_1_Bit_Full_Adder (input GCLK, input A, input B, input CI, output O , output CO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 `else 
   reg funkce1;
   reg funkce2;
`endif

initial begin
  funkce1 = 1'b0;
  funkce2 = 1'b0;
end

wire w1;
wire w2;
   assign w1 = A ^ B ^ CI;
   assign w2 = ( A & B) | ((A ^ B) & CI);

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

`ifdef PRIDAT_VYSTUPNI_LATCH  
  assign O=funkce1;
  assign CO=funkce2;
`else 
  assign O=w1;
  assign CO=w2;
`endif

endmodule
 
// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F601_D_Latch (input GCLK, input I ,input  CLK, output O, output nO);

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 `else 
   reg funkce1;
   reg funkce2;
`endif

initial begin
  funkce1 = 1'b0;
  funkce2 = 1'b1;
end

wire w1;
wire w2;
LDCE ld601( .D(I), .G(CLK), .Q(w1), .CLR(1'b0), .GE(1'b1) );
assign w2=!w1;

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)
module F604_D_Latch_C(input GCLK, input I ,input  nCLK, output O, output nO);

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 `else 
   reg funkce1;
   reg funkce2;
`endif

initial begin
  funkce1 = 1'b0;
  funkce2 = 1'b1;
end

wire w1;
wire w2;
LDCE ld601( .D(I), .G(!nCLK), .Q(w1), .CLR(1'b0), .GE(1'b1) );
assign w2=!w1;

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;


endmodule

// --------------------------


module DELAY(input GCLK, input I, output O );

`ifdef PREKLAD_PRO_VIVADO    
  (* ASYNC_REG = "TRUE" *) reg out1_reg;
`else 
  reg out1_reg;
`endif

wire out1_next;
  
always @(posedge GCLK)
begin
  out1_reg <= out1_next;
end

assign out1_next = I;
assign O = out1_reg;

endmodule


// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F611_D_Type_Flip_Flop ( input GCLK, input I, input CLK, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

initial begin
  w1 = 1'b0;
  w2 = 1'b1;
end


always @(posedge CLK) 
begin
  w1 = I;
  w2 = !I;
end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------



(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F612_D_Type_Flip_Flop_Reset ( input GCLK, input I, input CLK, input RES, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

initial begin
  w1 = 1'b0;
  w2 = 1'b1;
  funkce1= 1'b0;
  funkce2= 1'b1;
end

always @(posedge CLK or posedge RES) 
begin
  if (RES) 
  begin
    w1 = 1'b0;
    w2 = 1'b1;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F615_D_Type_Flip_Flop_Inv_Reset ( input GCLK, input I, input CLK, input nRES, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

initial begin
  w1 = 1'b0;
  w2 = 1'b1;
end

always @(posedge CLK or negedge nRES) 
begin
  if (!nRES) 
  begin
    w1 = 1'b0;
    w2 = 1'b1;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F616_D_Type_Flip_Flop_Inv_Set ( input GCLK, input I, input CLK, input nSET, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

initial begin
  w1 = 1'b0;
  w2 = 1'b1;
end

always @(posedge CLK or negedge nSET) 
begin
  if (!nSET) 
  begin
    w1 = 1'b1;
    w2 = 1'b0;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------


(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F617_D_Type_Flip_Flop_Inv_Set_Inv_Reset ( input GCLK, input I, input CLK, input nRES, input nSET, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif


initial begin
  w1 = 1'b0;
  w2 = 1'b1;
  funkce1 = 1'b0;
  funkce2 = 1'b1;
end


always @(posedge CLK or negedge nSET or negedge nRES) 
begin
  if (!nRES) 
  begin
    w1 <= 1'b0;
    w2 <= 1'b1;
  end 
  else 
    if (!nSET) 
    begin
      w1 <= 1'b1;
      w2 <= 1'b0;
    end 
    else
    begin
     w1 <= I;
     w2 <= !I;
    end
end



always @(posedge GCLK)
begin
  funkce1 <= w1;
  funkce2 <= w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

//`ifdef POUZE_PRO_SIMULACI    
//assign qw1 = nRES ? 1'b0 : (nSET ? 1'b1 : w1);
//assign qw2 = nRES ? 1'b1 : (nSET ? 1'b0 : w2);

//if ( nRES && !nSET ) force qw1=1;
//else release qw1;
//if ( nRES && !nSET ) force qw2=0;
//else release qw2;
//`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F617_D_Type_Flip_Flop_Inv_Set_Inv_Reset_not_o ( input GCLK, input I, input CLK, input nRES, input nSET, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 //(* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 //(* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
 //  reg funkce1;
   reg funkce2;
//   reg w1;
   reg w2;
`endif


initial begin
  //w1 = 1'b0;
  w2 = 1'b1;
  //funkce1 = 1'b0;
  funkce2 = 1'b1;
end


always @(posedge CLK or negedge nSET or negedge nRES) 
begin
  if (!nRES) 
  begin
    //w1 <= 1'b0;
    w2 <= 1'b1;
  end 
  else 
    if (!nSET) 
    begin
    //  w1 <= 1'b1;
      w2 <= 1'b0;
    end 
    else
    begin
  //   w1 <= I;
     w2 <= !I;
    end
end



always @(posedge GCLK)
begin
//  funkce1 <= w1;
  funkce2 <= w2;
end  

  //assign O=funkce1;
  assign nO=funkce2;

//`ifdef POUZE_PRO_SIMULACI    
//assign qw1 = nRES ? 1'b0 : (nSET ? 1'b1 : w1);
//assign qw2 = nRES ? 1'b1 : (nSET ? 1'b0 : w2);

//if ( nRES && !nSET ) force qw1=1;
//else release qw1;
//if ( nRES && !nSET ) force qw2=0;
//else release qw2;
//`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F617_D_Type_Flip_Flop_Inv_Set_Inv_Reset_not_no ( input GCLK, input I, input CLK, input nRES, input nSET, output O );

`ifdef PREKLAD_PRO_VIVADO111    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 //(* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 //(* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
 //  reg funkce2;
   reg w1;
//   reg w2;
`endif


initial begin
  w1 = 1'b0;
  //w2 = 1'b1;
  funkce1 = 1'b0;
  //funkce2 = 1'b1;
end


always @(posedge CLK or negedge nSET or negedge nRES) 
begin
  if (!nRES) 
  begin
    w1 <= 1'b0;
  //  w2 <= 1'b1;
  end 
  else 
    if (!nSET) 
    begin
      w1 <= 1'b1;
   //   w2 <= 1'b0;
    end 
    else
    begin
     w1 <= I;
//     w2 <= !I;
    end
end



always @(posedge GCLK)
begin
  funkce1 <= w1;
 // funkce2 <= w2;
end  

  assign O=funkce1;
//  assign nO=funkce2;

//`ifdef POUZE_PRO_SIMULACI    
//assign qw1 = nRES ? 1'b0 : (nSET ? 1'b1 : w1);
//assign qw2 = nRES ? 1'b1 : (nSET ? 1'b0 : w2);

//if ( nRES && !nSET ) force qw1=1;
//else release qw1;
//if ( nRES && !nSET ) force qw2=0;
//else release qw2;
//`endif

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F631_D_Type_Flip_Flop_C ( input GCLK, input I, input nCLK, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif


always @(negedge nCLK) 
begin
  w1 = I;
  w2 = !I;
end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------


(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F635_D_Type_Flip_Flop_C_Inv_Reset ( input GCLK, input I, input nCLK, input nRES, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

always @(negedge nCLK or negedge nRES) 
begin
  if (!nRES) 
  begin
    w1 = 1'b0;
    w2 = 1'b1;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------

(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F641_D_Type_Buffered_Flip_Flop ( input GCLK, input I, input CLK, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

initial begin
  w1 = 1'b0;
  w2 = 1'b1;
end

always @(posedge CLK) 
begin
  w1 = I;
  w2 = !I;
end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------



(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F642_D_Type_Buffered_Flip_Flop_Reset ( input GCLK, input I, input CLK, input RES, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

initial begin
  w1 = 1'b0;
  w2 = 1'b1;
  funkce1 = 1'b0;
  funkce2 = 1'b1;
end

always @(posedge CLK or posedge RES) 
begin
  if (RES) 
  begin
    w1 = 1'b0;
    w2 = 1'b1;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------


(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F645_D_Type_Buffered_Flip_Flop_Inv_Reset ( input GCLK, input I, input CLK, input nRES, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

always @(posedge CLK or negedge nRES) 
begin
  if (!nRES) 
  begin
    w1 = 1'b0;
    w2 = 1'b1;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------


(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F666_D_Type_Buffered_Flip_Flop_C_Inv_Set ( input GCLK, input I, input nCLK, input nSET, output O, output nO );

`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg funkce1;
 (* ASYNC_REG = "TRUE" *) reg funkce2;
 (* ASYNC_REG = "TRUE" *) reg w1;
 (* ASYNC_REG = "TRUE" *) reg w2;
 `else 
   reg funkce1;
   reg funkce2;
   reg w1;
   reg w2;
`endif

always @(negedge nCLK or negedge nSET) 
begin
  if (!nSET) 
  begin
    w1 = 1'b1;
    w2 = 1'b0;
  end 
  else 
  begin
   w1 = I;
   w2 = !I;
  end

end

always @(posedge GCLK)
begin
  funkce1 = w1;
  funkce2 = w2;
end  

  assign O=funkce1;
  assign nO=funkce2;

endmodule

// --------------------------


(* keep_hierarchy = "yes" *)
(* DONT_TOUCH = "yes" *)

module F961_4_Bit_Counter ( input  GCLK, input I1, input I2, input I3, input I4, output O1, output O2, output O3, output O4, input nSET, input nRES, input CLK, input ENABLE, input CARRY_IN, output CARRY_OUT );
`ifdef PREKLAD_PRO_VIVADO    
 (* ASYNC_REG = "TRUE" *) reg [3:0] regDATA;
 (* ASYNC_REG = "TRUE" *) reg dummy1;
 `else 
   reg [3:0] regDATA;
   reg dummy1;
`endif


always @(posedge GCLK)  // nejak se musi vyuzit GCLK aby nebyla chyba pri prekladu
begin
  dummy1 <= 1'b1;
end  

initial begin
   regDATA = 1'b0;
end


  always @(posedge CLK or negedge nRES or negedge nSET) begin
    if (!nRES) begin
	  regDATA <= 4'b0000;
    end 
    else 
    if (!nSET) begin
      regDATA <= {I4 , I3 , I2 , I1};
    end 
    else 
    if ( ENABLE && CARRY_IN ) begin
       regDATA = regDATA+1;
    end
  end
   
   //assign CARRY_OUT = (O4 & O3 & O2 & O1 & CARRY_IN  & ENABLE );
   assign CARRY_OUT = (O4 & O3 & O2 & O1 & ENABLE );
   assign O4 = regDATA[3];
   assign O3 = regDATA[2];
   assign O2 = regDATA[1];
   assign O1 = regDATA[0];

endmodule

